<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_Discount ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_Discount extends AbstractStructArrayBase
{
    /**
     * The AdultAdditional
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_Discount[]
     */
    public $AdultAdditional;
    /**
     * Constructor method for ArrayOfJPSOAP_Discount
     * @uses ArrayOfJPSOAP_Discount::setAdultAdditional()
     * @param \StructType\JPSOAP_Discount[] $adultAdditional
     */
    public function __construct(array $adultAdditional = array())
    {
        $this
            ->setAdultAdditional($adultAdditional);
    }
    /**
     * Get AdultAdditional value
     * @return \StructType\JPSOAP_Discount[]|null
     */
    public function getAdultAdditional()
    {
        return $this->AdultAdditional;
    }
    /**
     * This method is responsible for validating the values passed to the setAdultAdditional method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdultAdditional method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdultAdditionalForArrayConstraintsFromSetAdultAdditional(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_DiscountAdultAdditionalItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_DiscountAdultAdditionalItem instanceof \StructType\JPSOAP_Discount) {
                $invalidValues[] = is_object($arrayOfJPSOAP_DiscountAdultAdditionalItem) ? get_class($arrayOfJPSOAP_DiscountAdultAdditionalItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_DiscountAdultAdditionalItem), var_export($arrayOfJPSOAP_DiscountAdultAdditionalItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdultAdditional property can only contain items of type \StructType\JPSOAP_Discount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdultAdditional value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount[] $adultAdditional
     * @return \ArrayType\ArrayOfJPSOAP_Discount
     */
    public function setAdultAdditional(array $adultAdditional = array())
    {
        // validation for constraint: array
        if ('' !== ($adultAdditionalArrayErrorMessage = self::validateAdultAdditionalForArrayConstraintsFromSetAdultAdditional($adultAdditional))) {
            throw new \InvalidArgumentException($adultAdditionalArrayErrorMessage, __LINE__);
        }
        $this->AdultAdditional = $adultAdditional;
        return $this;
    }
    /**
     * Add item to AdultAdditional value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount $item
     * @return \ArrayType\ArrayOfJPSOAP_Discount
     */
    public function addToAdultAdditional(\StructType\JPSOAP_Discount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_Discount) {
            throw new \InvalidArgumentException(sprintf('The AdultAdditional property can only contain items of type \StructType\JPSOAP_Discount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdultAdditional[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_Discount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_Discount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdultAdditional
     */
    public function getAttributeName()
    {
        return 'AdultAdditional';
    }
}
